''**************************************
''
''  Brilldea W5100 Driver Demo Ver. 00.1
''
''  Timothy D. Swieter, E.I.
''  Brilldea - purveyor of prototyping goods
''  www.brilldea.com
''
''  Copyright (c) 2010 Timothy D. Swieter, E.I.
''  See end of file for terms of use.
''
''  Updated: February 15, 2010
''
''Description:
''
''
''Reference:
''
''To do:
''
''
''Revision Notes:
'' 0.1 Start of design.
''
''**************************************
CON               'Constants to be located here
'***************************************                       
  '***************************************
  ' Firmware Version
  '***************************************
  FWmajor       = 0
  FWminor       = 1

DAT
  TxtFWdate   byte "February 15, 2010",0
  
CON

  '***************************************
  ' Processor Settings
  '***************************************
  _clkmode = xtal1 + pll16x     'Use the PLL to multiple the external clock by 16
  _xinfreq = 5_000_000          'An external clock of 5MHz. is used (80MHz. operation)

  '***************************************
  ' System Definitions     
  '***************************************

  _OUTPUT       = 1             'Sets pin to output in DIRA register
  _INPUT        = 0             'Sets pin to input in DIRA register  
  _HIGH         = 1             'High=ON=1=3.3V DC
  _ON           = 1
  _LOW          = 0             'Low=OFF=0=0V DC
  _OFF          = 0
  _ENABLE       = 1             'Enable (turn on) function/mode
  _DISABLE      = 0             'Disable (turn off) function/mode
  _trueHex      = $FF           'True in hex
  _falseHex     = $00           'Fales in hex

  '***************************************
  ' I/O Definitions of PropNET Module
  '***************************************

  '~~~~Propeller Based I/O~~~~

  'User Interface
  _UI_btnled    = 23            'Combination button/LED.  Output High = LED on, no switch reading. Input = input reading, LED follows button.                                                                                                                                 

  'One-wire Interface
  _OW           = 17            'One-wire I/O line dependent on solder jumper on board.  Shared with uSD-data1.
' _OW           = 13            'One-wire I/O line dependent on solder jumper on board.  Shared with WIZ-int.

  'uSD Card Interface
  _uSD_cd       = 22            'Card detection dependent on solder jumper on board.
' _uSD_data2    = 18            'SPI Mode unused,        Other = data bit 2 dependent on solder jumper on board.
  _uSD_data3    = 19            'SPI Mode = chip select, Other = data bit 3
  _uSD_cmd      = 20            'SPI Mode = MOSI (DI),   Other = command.
  _uSD_clk      = 21            'Serial clock
  _uSD_data0    = 16            'SPI Mode = MISO, (DO),  Other = data bit 0
' _uSD_data1    = 17            'SPI Mode unused,        Other = data bit 1 dependent on solder jumper on board.


  'W5100 Module Interface
  _WIZ_data0    = 0             'SPI Mode = MISO, Indirect Mode = data bit 0.
  _WIZ_miso     = 0
  _WIZ_data1    = 1             'SPI Mode = MOSI, Indirect Mode = data bit 1.
  _WIZ_mosi     = 1
  _WIZ_data2    = 2             'SPI Mode unused, Indirect Mode = data bit 2 dependent on solder jumper on board.
  _WIZ_data3    = 3             'SPI Mode = SCLK, Indirect Mode = data bit 3.
  _WIZ_sclk     = 3
  _WIZ_data4    = 4             'SPI Mode unused, Indirect Mode = data bit 4 dependent on solder jumper on board.
  _WIZ_data5    = 5             'SPI Mode unused, Indirect Mode = data bit 5 dependent on solder jumper on board.
  _WIZ_data6    = 6             'SPI Mode unused, Indirect Mode = data bit 6 dependent on solder jumper on board.
  _WIZ_data7    = 7             'SPI Mode unused, Indirect Mode = data bit 7 dependent on solder jumper on board.
  _WIZ_addr0    = 8             'SPI Mode unused, Indirect Mode = address bit 0 dependent on solder jumper on board.
  _WIZ_addr1    = 9             'SPI Mode unused, Indirect Mode = address bit 1 dependent on solder jumper on board.
  _WIZ_wr       = 10            'SPI Mode unused, Indirect Mode = /write dependent on solder jumper on board.
  _WIZ_rd       = 11            'SPI Mode unused, Indirect Mode = /read dependent on solder jumper on board.
  _WIZ_cs       = 12            'SPI Mode unused, Indirect Mode = /chip select dependent on solder jumper on board.
  _WIZ_int      = 13            'W5100 /interrupt dependent on solder jumper on board.  Shared with _OW.
  _WIZ_rst      = 14            'W5100 chip reset.
  _WIZ_scs      = 15            'SPI Mode SPI Slave Select, Indirect Mode unused dependent on solder jumper on board.

  'MoBo Interface
  _MOBO_aux0    = 24            '
  _MOBO_aux1    = 25            '
  _MOBO_aux2    = 26            '
  _MOBO_aux3    = 27            '

  'I2C Interface
  _I2C_scl      = 28            'Output for the I2C serial clock
  _I2C_sda      = 29            'Input/output for the I2C serial data  

  'Serial/Programming Interface (via Prop Plug Header)
  _SERIAL_tx    = 30            'Output for sending misc. serial communications via a Prop Plug
  _SERIAL_rx    = 31            'Input for receiving misc. serial communications via a Prop Plug

  '***************************************
  ' I2C Definitions
  '***************************************
  _EEPROM0_address = $A0        'Slave address of EEPROM
  _RTC_address     = $D0        'Slave address of RTC from ST Micro (may be different for Seiko)

  '***************************************
  ' Debugging Definitions
  '***************************************
  
  '***************************************
  ' Misc Definitions
  '***************************************

  'none

'**************************************
VAR               'Variables to be located here
'***************************************

  byte  MAC[6]                  '6 element array contianing MAC or source hardware address ex. "00:08:DC:01:02:03"
  byte  Gateway[4]              '4 element array containing gateway address ex. "192.168.0.1"
  byte  Subnet[4]               '4 element array contianing subnet mask ex. "255.255.255.0"
  byte  IP[4]                   '4 element array containing IP address ex. "192.168.0.13"

'***************************************
OBJ               'Object declaration to be located here
'***************************************

  ETHERNET      : "Brilldea_W5100_SPI_Driver_Ver001.spin"
  PST           : "Parallax Serial Terminal.spin"       'A terminal object created by Parallax, used for debugging

'***************************************
PUB main
'***************************************
''  First routine to be executed in the program
''  because it is first PUB in the file

  PauseMSec(3_000)              'A small delay to allow time to switch to the terminal application

  '**************************************
  ' Start the processes in their cogs
  '**************************************

  'Start the terminal application
  'The terminal operates at 115,200 BAUD on the USB/COM Port the Prop Plug is attached to
  PST.Start(115_200)

  'Start the W5100 SPI driver
  ETHERNET.StartSPI(_WIZ_scs, _WIZ_sclk, _WIZ_mosi, _WIZ_miso, _WIZ_rst)
  PauseMSec(100)

  '**************************************
  ' Initialize the variables
  '**************************************

  'MAC ID
  MAC[0] := $C0
  MAC[1] := $A8
  MAC[2] := $00
  MAC[3] := $01
  MAC[4] := $00
  MAC[5] := $00

  'Gateway address
  Gateway[0] := 192
  Gateway[1] := 168
  Gateway[2] := 10
  Gateway[3] := 1

  'Subnet address
  Subnet[0] := 255
  Subnet[1] := 255
  Subnet[2] := 255
  Subnet[3] := 0

  'IP address
  IP[0] := 192
  IP[1] := 168
  IP[2] := 10
  IP[3] := 75
  
  '**************************************
  ' Begin
  '**************************************

  'Clear the terminal screen
  PST.Home
  PST.Clear
   
  'Draw the title bar
  PST.Str(string("  W5100 SPI Driver Test  ", PST#NL, PST#NL))

  SetVerifyMAC(@MAC[0])
  SetVerifyGateway(@Gateway[0])
  SetVerifySubnet(@Subnet[0])
  SetVerifyIP(@IP[0])

  PauseMSec(3_000)

  ETHERNET.PingBlock(true, true)
  PST.Str(string("PING now blocked", PST#NL, PST#NL))

  PauseMSec(3_000)

' ETHERNET.ResetHardware(true)
  ETHERNET.ResetSoftware(true)
  PST.Str(string("Resetting W5100", PST#NL))

  SetVerifyMAC(@MAC[0])
  SetVerifyGateway(@Gateway[0])
  SetVerifySubnet(@Subnet[0])
  SetVerifyIP(@IP[0])

  repeat

  return 'end of main
  
'***************************************
PRI SetVerifyMAC(_firstOctet) | temp0
'***************************************

  'Set the MAC ID and display it in the terminal
  ETHERNET.SetMACAddress(true, byte[_firstOctet + 0],byte[_firstOctet + 1],byte[_firstOctet + 2],byte[_firstOctet + 3],byte[_firstOctet + 4],byte[_firstOctet + 5])

  PST.Str(string("Set MAC ID......"))
  PST.hex(byte[_firstOctet + 0], 2)
  PST.Str(string(":"))
  PST.hex(byte[_firstOctet + 1], 2)
  PST.Str(string(":"))
  PST.hex(byte[_firstOctet + 2], 2)
  PST.Str(string(":"))
  PST.hex(byte[_firstOctet + 3], 2)
  PST.Str(string(":"))
  PST.hex(byte[_firstOctet + 4], 2)
  PST.Str(string(":"))
  PST.hex(byte[_firstOctet + 5], 2)
  PST.Str(string(PST#NL))

  'Wait a moment
  PauseMSec(500)

  temp0 := ETHERNET.readMACAddress
  
  PST.Str(string("Verify MAC ID..."))
  PST.hex(byte[temp0 + 0], 2)
  PST.Str(string(":"))
  PST.hex(byte[temp0 + 1], 2)
  PST.Str(string(":"))
  PST.hex(byte[temp0 + 2], 2)
  PST.Str(string(":"))
  PST.hex(byte[temp0 + 3], 2)
  PST.Str(string(":"))
  PST.hex(byte[temp0 + 4], 2)
  PST.Str(string(":"))
  PST.hex(byte[temp0 + 5], 2)
  PST.Str(string(PST#NL))
  PST.Str(string(PST#NL))

  return 'end of SetVerifyMAC

'***************************************
PRI SetVerifyGateway(_firstOctet) | temp0
'***************************************

  'Set the Gatway address and display it in the terminal
  ETHERNET.SetGatewayAddress(true, byte[_firstOctet + 0],byte[_firstOctet + 1],byte[_firstOctet + 2],byte[_firstOctet + 3])

  PST.Str(string("Set Gateway....."))
  PST.dec(byte[_firstOctet + 0])
  PST.Str(string("."))
  PST.dec(byte[_firstOctet + 1])
  PST.Str(string("."))
  PST.dec(byte[_firstOctet + 2])
  PST.Str(string("."))
  PST.dec(byte[_firstOctet + 3])
  PST.Str(string(PST#NL))

  'Wait a moment
  PauseMSec(500)

  temp0 := ETHERNET.readGatewayAddress
  
  PST.Str(string("Verify Gateway.."))
  PST.dec(byte[temp0 + 0])
  PST.Str(string("."))
  PST.dec(byte[temp0 + 1])
  PST.Str(string("."))
  PST.dec(byte[temp0 + 2])
  PST.Str(string("."))
  PST.dec(byte[temp0 + 3])
  PST.Str(string(PST#NL))
  PST.Str(string(PST#NL))

  return 'end of SetVerifyGateway

'***************************************
PRI SetVerifySubnet(_firstOctet) | temp0
'***************************************

  'Set the Subnet address and display it in the terminal
  ETHERNET.SetSubnetMask(true, byte[_firstOctet + 0],byte[_firstOctet + 1],byte[_firstOctet + 2],byte[_firstOctet + 3])

  PST.Str(string("Set Subnet......"))
  PST.dec(byte[_firstOctet + 0])
  PST.Str(string("."))
  PST.dec(byte[_firstOctet + 1])
  PST.Str(string("."))
  PST.dec(byte[_firstOctet + 2])
  PST.Str(string("."))
  PST.dec(byte[_firstOctet + 3])
  PST.Str(string(PST#NL))

  'Wait a moment
  PauseMSec(500)

  temp0 := ETHERNET.readSubnetMask
  
  PST.Str(string("Verify Subnet..."))
  PST.dec(byte[temp0 + 0])
  PST.Str(string("."))
  PST.dec(byte[temp0 + 1])
  PST.Str(string("."))
  PST.dec(byte[temp0 + 2])
  PST.Str(string("."))
  PST.dec(byte[temp0 + 3])
  PST.Str(string(PST#NL))
  PST.Str(string(PST#NL))

  return 'end of SetVerifySubnet

'***************************************
PRI SetVerifyIP(_firstOctet) | temp0
'***************************************

  'Set the IP address and display it in the terminal
  ETHERNET.SetIPAddress(true, byte[_firstOctet + 0],byte[_firstOctet + 1],byte[_firstOctet + 2],byte[_firstOctet + 3])

  PST.Str(string("Set IP.........."))
  PST.dec(byte[_firstOctet + 0])
  PST.Str(string("."))
  PST.dec(byte[_firstOctet + 1])
  PST.Str(string("."))
  PST.dec(byte[_firstOctet + 2])
  PST.Str(string("."))
  PST.dec(byte[_firstOctet + 3])
  PST.Str(string(PST#NL))

  'Wait a moment
  PauseMSec(500)

  temp0 := ETHERNET.readIPAddress
  
  PST.Str(string("Verify IP......."))
  PST.dec(byte[temp0 + 0])
  PST.Str(string("."))
  PST.dec(byte[temp0 + 1])
  PST.Str(string("."))
  PST.dec(byte[temp0 + 2])
  PST.Str(string("."))
  PST.dec(byte[temp0 + 3])
  PST.Str(string(PST#NL))
  PST.Str(string(PST#NL))

  return 'end of SetVerifyIP

'***************************************
PRI PauseMSec(Duration)
'***************************************
''  Pause execution for specified milliseconds.
''  This routine is based on the set clock frequency.
''  
''  params:  Duration = number of milliseconds to delay                                                                                               
''  return:  none
  
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)

  return  'end of PauseMSec